<?php
// Version 10.1.3 - 25 October 2021
global $languages_path, $text;
if ( function_exists ('get_option') ) 
$wp_tng_path = get_option('mbtng_url');

//INSTALL NOTES

// Base tag cloud code borrowed from http://www.roscripts.com/Create_tag_cloud-71.html
// Integrated into TNG by Steven Willingale www.willingale.org & www.stevenwillingale.com

// you may need to change line 49 to point to your search page, usually at www.yourdomain.com/tng/search.php
// change the 2nd value in "DESC LIMIT 0 , 20" on line 61 to return the number of surnames you want in the tag cloud
// if you have a very large gap between the numbers of surnames ie the jones surname has 1,000 names and the next surname of  willingale has only 100, you may find the tag cloud does not size the names correctly
// line 19 & 20 need to point to the config & genlib files usually in the www.yourdomain.com/tng/ folder
// font colour change can be made on lines 72-76

/* SCRIPT DIRECTORY
=================
in the line below put the directory your user added scripts are in
inside the "" - eg userscripts*/

$userdirectory = "userscripts";

//THIS BLOCK OF CODE ALLOWS RUNNING THE SCRIPT AS A STANDALONE SCRIPT FOR TESTING PURPOSES

if (strpos($_SERVER['SCRIPT_NAME'], $userdirectory) > 0 ) {
//the script is being called from the $userdirectory directory
include_once("../begin.php");
if( !$cms['support'] )
	$cms['tngpath'] = "../";
include_once($cms['tngpath'] . "$custommeta");

	} else {

//the script is being called from the TNG directory or as an include
include_once("begin.php");
if( !$cms['support'] )
	$cms['tngpath'] = "";
}

include_once($cms['tngpath'] . "genlib.php");
include_once($cms['tngpath'] . "getlang.php");

tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;

//END OF BLOCK FOR STANDALONE OPERATION OF SCRIPT

include_once($cms['tngpath'] . "checklogin.php");
include_once($cms['tngpath'] . "$mylanguage/text.php");

function get_tag_cloud() {
global $tngdomain, $cms, $wp_tng_path;
// Default font sizes
$min_font_size = 12;
$max_font_size = 30;
$minimum_count = 5;

// Pull in tag data
$tags = get_tag_data();

        // largest and smallest array values
        $max_qty = max(array_values($tags));
        $min_qty = min(array_values($tags));
       
        // find the range of values
        $spread = $max_qty - $min_qty;

//Finally we start the HTML building process to display our tags. For this demo the tag simply searches Google using the provided tag.
$cloud_html = '';
$cloud_tags = array(); // create an array to hold tag code

if ( !empty($wp_tng_path )) {
// script is being called from a WordPress Widget Include
	$cms['tngpath'] = $wp_tng_path;
//} else {
// script is running either as an include on a page, or directly from the $userscripts folder
//	$cms['tngpath'] = $tngdomain;
}

foreach ($tags as $tag => $count) {

	$size = $min_font_size + ($count - $minimum_count) 
		* ($max_font_size - $min_font_size) / $spread;
	$cloud_tags[] = '<a style="font-size: '. floor($size) . 'px' 
		. '" class="tag_cloud" href="' . $cms['tngpath'] . 'search.php?mylastname=' . $tag 
		. '&amp;lnqualify=equals" title="\'' . $tag  . '\' returned a count of ' . $count . '">' 
		. htmlspecialchars(stripslashes($tag)) . '</a>';
// This code makes the tag could without links in it.
//	$cloud_tags[] = '<span style="font-size: '. floor($size) . 'px' 
//		. '" class="tag_cloud">' 
//		. htmlspecialchars(stripslashes($tag)) . '</span>';

			
}
$cloud_html = join("\n", $cloud_tags) . "\n";
return $cloud_html;
}

function get_tag_data() { 

// Edit the number in the line below to change the number of surnames returned

$maxnames = 50;

  $result = tng_query("SELECT lastname, count( lastname ) as mycount FROM `tng_people` WHERE lastname != \"\" AND lastname != \"[--?--]\" GROUP BY lastname ORDER BY count( lastname ) DESC LIMIT 0 ," . $maxnames ); 
  while($row = tng_fetch_array($result)) { 
    $arr[$row['lastname']] = $row['mycount'];

  } 
  ksort($arr); 
  return $arr; 

tng_free_result( $result );

}

?>

<div class="randomborder">
<!-- BEGIN Tag Cloud -->
<?php print get_tag_cloud(); ?>
<!-- END Tag Cloud -->
</div>